    PROGRAM c06gbfe

!      C06GBF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : c06eaf, c06gbf, c06gsf, nag_wp
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: ieof, ifail, j, m, n
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: a(:), b(:), x(:)
!      .. Executable Statements ..
       WRITE (nout,*) 'C06GBF Example Program Results'
!      Skip heading in data file
       READ (nin,*)
LOOP:  DO
          READ (nin,*,IOSTAT=ieof) n
          IF (ieof<0) EXIT LOOP

          ALLOCATE (a(0:n-1),b(0:n-1),x(0:n-1))
          READ (nin,*) x(0:n-1)

!         ifail: behaviour on error exit   
!                =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
          ifail = 0
          CALL c06eaf(x,n,ifail)

          CALL c06gbf(x,n,ifail)

          WRITE (nout,*)
          WRITE (nout,*) 'Components of inverse discrete Fourier transform'
          WRITE (nout,*)
          WRITE (nout,*) '           Real      Imag'
          WRITE (nout,*)

!         Convert x to separated real and imaginary parts for printing.
          ifail = 0
          m = 1
          CALL c06gsf(m,n,x,a,b,ifail)
          WRITE (nout,99999) (j,a(j),b(j),j=0,n-1)
          DEALLOCATE (a,b,x)
       END DO LOOP

99999  FORMAT (1X,I6,2F10.5)
    END PROGRAM c06gbfe
