    PROGRAM c06pafe

!      C06PAF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : c06paf, nag_wp
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: ieof, ifail, j, n, nj
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: work(:), x(:), xx(:)
!      .. Executable Statements ..
       WRITE (nout,*) 'C06PAF Example Program Results'
!      Skip heading in data file
       READ (nin,*)
LOOP:  DO
          READ (nin,*,IOSTAT=ieof) n
          IF (ieof<0) EXIT LOOP

          ALLOCATE (work(3*n+100),x(0:n+1),xx(0:n-1))
          READ (nin,*) x(0:n-1)
          xx(0:n-1) = x(0:n-1)

!         ifail: behaviour on error exit   
!                =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
          ifail = 0
          CALL c06paf('F',x,n,work,ifail)

          WRITE (nout,*)
          WRITE (nout,*) 'Components of discrete Fourier transform'
          WRITE (nout,*)
          WRITE (nout,*) '          Real      Imag'
          WRITE (nout,*)
          WRITE (nout,99999) (j,x(2*j),x(2*j+1),j=0,n/2)
          DO j = n/2 + 1, n - 1
             nj = n - j
             WRITE (nout,99999) j, x(2*nj), -x(2*nj+1)
          END DO

          CALL c06paf('B',x,n,work,ifail)

          WRITE (nout,*)
          WRITE (nout,*) 'Original sequence as restored by inverse transform'
          WRITE (nout,*)
          WRITE (nout,*) '        Original  Restored'
          WRITE (nout,*)
          WRITE (nout,99999) (j,xx(j),x(j),j=0,n-1)
          DEALLOCATE (work,x,xx)
       END DO LOOP

99999  FORMAT (1X,I5,2F10.5)
    END PROGRAM c06pafe
