    PROGRAM f07acfe

!      F07ACF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : dsgesv, nag_rp, nag_wp
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: i, info, iter, lda, ldb, ldx, n, r
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: a(:,:), b(:,:), work(:), x(:,:)
       REAL (KIND=nag_rp), ALLOCATABLE :: swork(:)
       INTEGER, ALLOCATABLE            :: ipiv(:)
!      .. Executable Statements ..
       WRITE (nout,*) 'F07ACF Example Program Results'
       WRITE (nout,*)
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n, r
       lda = n
       ldb = n
       ldx = n
       ALLOCATE (a(lda,n),b(n,r),work(n*r),x(ldx,r),swork(n*(n+r)),ipiv(n))

!      Read A and B from data file

       READ (nin,*) (a(i,1:n),i=1,n)
       READ (nin,*) (b(i,1:r),i=1,n)

!      Solve the equations Ax = b for x

!      The NAG name equivalent of dsgesv is f07acf
       CALL dsgesv(n,r,a,lda,ipiv,b,ldb,x,ldx,work,swork,iter,info)

       IF (info==0) THEN

!         Print solution

          WRITE (nout,*) 'Solution'
          WRITE (nout,99999) (x(i,1:r),i=1,n)

!         Print pivot indices

          WRITE (nout,*)
          WRITE (nout,*) 'Pivot indices'
          WRITE (nout,99998) ipiv(1:n)

       ELSE
          WRITE (nout,99997) 'The (', info, ',', info, ')', &
             ' element of the factor U is zero'
       END IF

99999  FORMAT ((3X,7F11.4))
99998  FORMAT ((3X,7I11))
99997  FORMAT (1X,A,I3,A,I3,A,A)
    END PROGRAM f07acfe
