    PROGRAM f07bdfe

!      F07BDF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : dgbtrf, nag_wp, x04cef
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: i, ifail, info, j, k, kl, ku, ldab,  &
                                          m, n
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: ab(:,:)
       INTEGER, ALLOCATABLE            :: ipiv(:)
!      .. Intrinsic Functions ..
       INTRINSIC                          max, min
!      .. Executable Statements ..
       WRITE (nout,*) 'F07BDF Example Program Results'
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) m, n, kl, ku
       ldab = 2*kl + ku + 1
       ALLOCATE (ab(ldab,n),ipiv(n))

!      Read A from data file

       k = kl + ku + 1
       READ (nin,*) ((ab(k+i-j,j),j=max(i-kl,1),min(i+ku,n)),i=1,m)

!      Factorize A
!      The NAG name equivalent of dgbtrf is f07bdf
       CALL dgbtrf(m,n,kl,ku,ab,ldab,ipiv,info)

!      Print details of factorization

       WRITE (nout,*)
       FLUSH (nout)

!      ifail: behaviour on error exit
!             =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
       ifail = 0
       CALL x04cef(m,n,kl,kl+ku,ab,ldab,'Details of factorization',ifail)

!      Print pivot indices

       WRITE (nout,*)
       WRITE (nout,*) 'IPIV'
       WRITE (nout,99999) ipiv(1:min(m,n))

       IF (info/=0) WRITE (nout,*) 'The factor U is singular'

99999  FORMAT ((3X,7I11))
    END PROGRAM f07bdfe
