    PROGRAM f07bgfe

!      F07BGF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : dgbcon, dgbtrf, dlangb => f06rbf, nag_wp, x02ajf
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
       CHARACTER (1), PARAMETER        :: norm = '1'
!      .. Local Scalars ..
       REAL (KIND=nag_wp)              :: anorm, rcond
       INTEGER                         :: i, info, j, k, kl, ku, ldab, n
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: ab(:,:), work(:)
       INTEGER, ALLOCATABLE            :: ipiv(:), iwork(:)
!      .. Intrinsic Functions ..
       INTRINSIC                          max, min
!      .. Executable Statements ..
       WRITE (nout,*) 'F07BGF Example Program Results'
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n, kl, ku
       ldab = 2*kl + ku + 1
       ALLOCATE (ab(ldab,n),work(3*n),ipiv(n),iwork(n))

!      Read A from data file

       k = kl + ku + 1
       READ (nin,*) ((ab(k+i-j,j),j=max(i-kl,1),min(i+ku,n)),i=1,n)

!      Compute norm of A
!      f06rbf is the NAG name equivalent of the LAPACK auxiliary dlangb
       anorm = dlangb(norm,n,kl,ku,ab(kl+1,1),ldab,work)

!      Factorize A

!      The NAG name equivalent of dgbtrf id f07bdf
       CALL dgbtrf(n,n,kl,ku,ab,ldab,ipiv,info)

       WRITE (nout,*)
       IF (info==0) THEN

!         Estimate condition number

!         The NAG name equivalent of dgbcon is f07bgf
          CALL dgbcon(norm,n,kl,ku,ab,ldab,ipiv,anorm,rcond,work,iwork,info)

          IF (rcond>=x02ajf()) THEN
             WRITE (nout,99999) 'Estimate of condition number =', &
                1.0_nag_wp/rcond
          ELSE
             WRITE (nout,*) 'A is singular to working precision'
          END IF
       ELSE
          WRITE (nout,*) 'The factor U is singular'
       END IF

99999  FORMAT (1X,A,1P,E10.2)
    END PROGRAM f07bgfe
