    PROGRAM f07fqfe

!      F07FQF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : nag_rp, nag_wp, zcposv
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: i, info, iter, lda, ldb, ldx, n, r
!      .. Local Arrays ..
       COMPLEX (KIND=nag_wp), ALLOCATABLE :: a(:,:), b(:,:), work(:,:), x(:,:)
       COMPLEX (KIND=nag_rp), ALLOCATABLE :: swork(:)
       REAL (KIND=nag_wp), ALLOCATABLE :: rwork(:)
!      .. Executable Statements ..
       WRITE (nout,*) 'F07FQF Example Program Results'
       WRITE (nout,*)
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n, r
       lda = n
       ldb = n
       ldx = n
       ALLOCATE (a(lda,n),b(ldb,r),work(n,r),x(ldx,r),swork(n*(n+r)),rwork(n))

!      Read A and B from data file

       READ (nin,*) (a(i,i:n),i=1,n)
       READ (nin,*) (b(i,1:r),i=1,n)

!      Solve the equations Ax = b for x
!      The NAG name equivalent of zcposv is f07fqf
       CALL zcposv('U',n,r,a,lda,b,ldb,x,ldx,work,swork,rwork,iter,info)

       IF (info==0) THEN

!         Print solution

          WRITE (nout,*) 'Solution'
          WRITE (nout,99999) (x(i,1:r),i=1,n)

       ELSE
          WRITE (nout,99998) 'The leading minor of order ', info, &
             ' is not positive definite'
       END IF

99999  FORMAT ((3X,4(' (',F7.4,',',F7.4,')':)))
99998  FORMAT (1X,A,I3,A)
    END PROGRAM f07fqfe
