    PROGRAM f07jgfe

!      F07JGF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : dlanst => f06rpf, dptcon, dpttrf, nag_wp, x02ajf
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       REAL (KIND=nag_wp)              :: anorm, rcond
       INTEGER                         :: info, n
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: d(:), e(:), work(:)
!      .. Executable Statements ..
       WRITE (nout,*) 'F07JGF Example Program Results'
       WRITE (nout,*)
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n

       ALLOCATE (d(n),e(n-1),work(n))

!      Read the lower bidiagonal part of the tridiagonal matrix A from
!      data file

       READ (nin,*) d(1:n)
       READ (nin,*) e(1:n-1)

!      Compute the 1-norm of A
!      f06rpf is the NAG name equivalent of the LAPACK auxiliary dlanst
       anorm = dlanst('1-norm',n,d,e)

!      Factorize the tridiagonal matrix A
!      The NAG name equivalent of dpttrf is f07jdf
       CALL dpttrf(n,d,e,info)

       IF (info==0) THEN

!         Estimate the condition number of A
!         The NAG name equivalent of dptcon is f07jgf
          CALL dptcon(n,d,e,anorm,rcond,work,info)

!         Print the estimated condition number

          IF (rcond>=x02ajf()) THEN
             WRITE (nout,99999) 'Estimate of condition number = ', &
                1.0_nag_wp/rcond
          ELSE
             WRITE (nout,99999) 'A is singular to working precision. RCOND = ' &
                , rcond
          END IF

       ELSE
          WRITE (nout,99998) 'The leading minor of order ', info, &
             ' is not positive definite'
       END IF

99999  FORMAT (1X,A,1P,E10.2)
99998  FORMAT (1X,A,I3,A)
    END PROGRAM f07jgfe
