    PROGRAM f07mdfe

!      F07MDF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : dsytrf, nag_wp, x04caf
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: i, ifail, info, lda, lwork, n
       CHARACTER (1)                   :: uplo
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: a(:,:), work(:)
       INTEGER, ALLOCATABLE            :: ipiv(:)
!      .. Executable Statements ..
       WRITE (nout,*) 'F07MDF Example Program Results'
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n
       lda = n
       lwork = 64*n
       ALLOCATE (a(lda,n),work(lwork),ipiv(n))

!      Read A from data file

       READ (nin,*) uplo
       IF (uplo=='U') THEN
          READ (nin,*) (a(i,i:n),i=1,n)
       ELSE IF (uplo=='L') THEN
          READ (nin,*) (a(i,1:i),i=1,n)
       END IF

!      Factorize A
!      The NAG name equivalent of dsytrf is f07mdf
       CALL dsytrf(uplo,n,a,lda,ipiv,work,lwork,info)

       WRITE (nout,*)
       FLUSH (nout)

!      Print details of factorization

!      ifail: behaviour on error exit
!             =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
       ifail = 0
       CALL x04caf(uplo,'Nonunit',n,n,a,lda,'Details of factorization',ifail)

!      Print pivot indices

       WRITE (nout,*)
       WRITE (nout,*) 'IPIV'
       WRITE (nout,99999) ipiv(1:n)

       IF (info/=0) WRITE (nout,*) 'The factor D is singular'

99999  FORMAT ((3X,7I11))
    END PROGRAM f07mdfe
