    PROGRAM f07tgfe

!      F07TGF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : dtrcon, nag_wp, x02ajf
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
       CHARACTER (1), PARAMETER        :: diag = 'N', norm = '1'
!      .. Local Scalars ..
       REAL (KIND=nag_wp)              :: rcond
       INTEGER                         :: i, info, lda, n
       CHARACTER (1)                   :: uplo
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: a(:,:), work(:)
       INTEGER, ALLOCATABLE            :: iwork(:)
!      .. Executable Statements ..
       WRITE (nout,*) 'F07TGF Example Program Results'
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n
       lda = n
       ALLOCATE (a(lda,n),work(3*n),iwork(n))

!      Read A from data file

       READ (nin,*) uplo
       IF (uplo=='U') THEN
          READ (nin,*) (a(i,i:n),i=1,n)
       ELSE IF (uplo=='L') THEN
          READ (nin,*) (a(i,1:i),i=1,n)
       END IF

!      Estimate condition number
!      The NAG name equivalent of dtrcon is f07tgf
       CALL dtrcon(norm,uplo,diag,n,a,lda,rcond,work,iwork,info)

       WRITE (nout,*)
       IF (rcond>=x02ajf()) THEN
          WRITE (nout,99999) 'Estimate of condition number =', &
             1.0E0_nag_wp/rcond
       ELSE
          WRITE (nout,*) 'A is singular to working precision'
       END IF

99999  FORMAT (1X,A,1P,E10.2)
    END PROGRAM f07tgfe
