    PROGRAM f07thfe

!      F07THF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : dtrrfs, dtrtrs, nag_wp, x04caf
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
       CHARACTER (1), PARAMETER        :: diag = 'N', trans = 'N'
!      .. Local Scalars ..
       INTEGER                         :: i, ifail, info, lda, ldb, ldx, n, nrhs
       CHARACTER (1)                   :: uplo
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: a(:,:), b(:,:), berr(:), ferr(:),    &
                                          work(:), x(:,:)
       INTEGER, ALLOCATABLE            :: iwork(:)
!      .. Executable Statements ..
       WRITE (nout,*) 'F07THF Example Program Results'
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n, nrhs
       lda = n
       ldb = n
       ldx = n
       ALLOCATE (a(lda,n),b(ldb,nrhs),berr(nrhs),ferr(nrhs),work(3*n), &
          x(ldx,n),iwork(n))

!      Read A and B from data file, and copy B to X

       READ (nin,*) uplo
       IF (uplo=='U') THEN
          READ (nin,*) (a(i,i:n),i=1,n)
       ELSE IF (uplo=='L') THEN
          READ (nin,*) (a(i,1:i),i=1,n)
       END IF
       READ (nin,*) (b(i,1:nrhs),i=1,n)

       x(1:n,1:nrhs) = b(1:n,1:nrhs)

!      Compute solution in the array X
!      The NAG name equivalent of dtrtrs is f07tef
       CALL dtrtrs(uplo,trans,diag,n,nrhs,a,lda,x,ldx,info)

!      Compute backward errors and estimated bounds on the
!      forward errors

!      The NAG name equivalent of dtrrfs is f07thf
       CALL dtrrfs(uplo,trans,diag,n,nrhs,a,lda,b,ldb,x,ldx,ferr,berr,work, &
          iwork,info)

!      Print solution

       WRITE (nout,*)
       FLUSH (nout)

!      ifail: behaviour on error exit
!             =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
       ifail = 0
       CALL x04caf('General',' ',n,nrhs,x,ldx,'Solution(s)',ifail)

       WRITE (nout,*)
       WRITE (nout,*) 'Backward errors (machine-dependent)'
       WRITE (nout,99999) berr(1:nrhs)
       WRITE (nout,*) 'Estimated forward error bounds (machine-dependent)'
       WRITE (nout,99999) ferr(1:nrhs)

99999  FORMAT ((3X,1P,7E11.1))
    END PROGRAM f07thfe
