    PROGRAM f07uefe

!      F07UEF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : dtptrs, nag_wp, x04caf
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
       CHARACTER (1), PARAMETER        :: diag = 'N', trans = 'N'
!      .. Local Scalars ..
       INTEGER                         :: i, ifail, info, j, ldb, n, nrhs
       CHARACTER (1)                   :: uplo
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: ap(:), b(:,:)
!      .. Executable Statements ..
       WRITE (nout,*) 'F07UEF Example Program Results'
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n, nrhs
       ldb = n
       ALLOCATE (ap(n*(n+1)/2),b(ldb,nrhs))

!      Read A and B from data file

       READ (nin,*) uplo
       IF (uplo=='U') THEN
          READ (nin,*) ((ap(i+j*(j-1)/2),j=i,n),i=1,n)
       ELSE IF (uplo=='L') THEN
          READ (nin,*) ((ap(i+(2*n-j)*(j-1)/2),j=1,i),i=1,n)
       END IF
       READ (nin,*) (b(i,1:nrhs),i=1,n)

!      Compute solution
!      The NAG name equivalent of dtptrs is f07uef
       CALL dtptrs(uplo,trans,diag,n,nrhs,ap,b,ldb,info)

!      Print solution

       WRITE (nout,*)
       FLUSH (nout)
       IF (info==0) THEN

!         ifail: behaviour on error exit
!                =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
          ifail = 0
          CALL x04caf('General',' ',n,nrhs,b,ldb,'Solution(s)',ifail)

       ELSE
          WRITE (nout,*) 'A is singular'
       END IF

    END PROGRAM f07uefe
