    PROGRAM f07vgfe

!      F07VGF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : dtbcon, nag_wp, x02ajf
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
       CHARACTER (1), PARAMETER        :: diag = 'N', norm = '1'
!      .. Local Scalars ..
       REAL (KIND=nag_wp)              :: rcond
       INTEGER                         :: i, info, j, kd, ldab, n
       CHARACTER (1)                   :: uplo
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: ab(:,:), work(:)
       INTEGER, ALLOCATABLE            :: iwork(:)
!      .. Intrinsic Functions ..
       INTRINSIC                          max, min
!      .. Executable Statements ..
       WRITE (nout,*) 'F07VGF Example Program Results'
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n, kd
       ldab = kd + 1
       ALLOCATE (ab(ldab,n),work(3*n),iwork(n))

!      Read A from data file

       READ (nin,*) uplo
       IF (uplo=='U') THEN
          DO i = 1, n
             READ (nin,*) (ab(kd+1+i-j,j),j=i,min(n,i+kd))
          END DO
       ELSE IF (uplo=='L') THEN
          DO i = 1, n
             READ (nin,*) (ab(1+i-j,j),j=max(1,i-kd),i)
          END DO
       END IF

!      Estimate condition number
!      The NAG name equivalent of dtbcon is f07vgf
       CALL dtbcon(norm,uplo,diag,n,kd,ab,ldab,rcond,work,iwork,info)

       WRITE (nout,*)
       IF (rcond>=x02ajf()) THEN
          WRITE (nout,99999) 'Estimate of condition number =', &
             1.0E0_nag_wp/rcond
       ELSE
          WRITE (nout,*) 'A is singular to working precision'
       END IF

99999  FORMAT (1X,A,1P,E10.2)
    END PROGRAM f07vgfe
