    PROGRAM f08cwfe

!      F08CWF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : nag_wp, x04dbf, zgerqf, zungrq
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nb = 64, nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: i, ifail, info, lda, lwork, m, n
       CHARACTER (26)                  :: title
!      .. Local Arrays ..
       COMPLEX (KIND=nag_wp), ALLOCATABLE :: a(:,:), tau(:), work(:)
       CHARACTER (1)                   :: clabs(1), rlabs(1)
!      .. Executable Statements ..
       WRITE (nout,*) 'F08CWF Example Program Results'
       WRITE (nout,*)
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) m, n
       lda = m
       lwork = nb*m
       ALLOCATE (a(lda,n),tau(n),work(lwork))

!      Read A from data file

       READ (nin,*) (a(i,1:n),i=1,m)

!      Compute the RQ factorization of A
!      The NAG name equivalent of zgerqf is f08cvf
       CALL zgerqf(m,n,a,lda,tau,work,lwork,info)

!      Form the leading M rows of Q explicitly
!      The NAG name equivalent of zungrq is f08cwf
       CALL zungrq(m,n,m,a,lda,tau,work,lwork,info)

!      Form the heading for X04DBF

       WRITE (title,99999) m
       FLUSH (nout)

!      Print the leading M rows of Q

!      ifail: behaviour on error exit
!             =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
       ifail = 0
       CALL x04dbf('General',' ',m,n,a,lda,'Bracketed','F7.4',title,'Integer', &
          rlabs,'Integer',clabs,80,0,ifail)

99999  FORMAT ('The leading ',I4,' rows of Q')
    END PROGRAM f08cwfe
