    PROGRAM f08jefe

!      F08JEF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : dsteqr, nag_wp, x04caf
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: i, ifail, info, ldz, n
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: d(:), e(:), work(:), z(:,:)
!      .. Executable Statements ..
       WRITE (nout,*) 'F08JEF Example Program Results'
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n
       ldz = n
       ALLOCATE (d(n),e(n-1),work(2*n-2),z(ldz,n))

!      Read T from data file

       READ (nin,*) d(1:n)
       READ (nin,*) e(1:n-1)

!      Calculate all the eigenvalues and eigenvectors of T
!      The NAG name equivalent of dsteqr is f08jef
       CALL dsteqr('I',n,d,e,z,ldz,work,info)

       WRITE (nout,*)
       IF (info>0) THEN
          WRITE (nout,*) 'Failure to converge.'
       ELSE

!         Print eigenvalues and eigenvectors

          WRITE (nout,*) 'Eigenvalues'
          WRITE (nout,99999) d(1:n)
          WRITE (nout,*)
          FLUSH (nout)

!         Standardize the eigenvectors so that first elements are non-negative.
          DO i = 1, n
             IF (z(1,i)<0.0_nag_wp)  z(1:n,i) = -z(1:n,i)
          END DO

!         ifail: behaviour on error exit
!                =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
          ifail = 0
          CALL x04caf('General',' ',n,n,z,ldz,'Eigenvectors',ifail)

       END IF

99999  FORMAT (3X,(8F8.4))
    END PROGRAM f08jefe
