    PROGRAM f08nsfe

!      F08NSF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : nag_wp, x04dbf, zgehrd
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       COMPLEX (KIND=nag_wp), PARAMETER :: zero = (0.0E0_nag_wp,0.0E0_nag_wp)
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: i, ifail, info, lda, lwork, n
!      .. Local Arrays ..
       COMPLEX (KIND=nag_wp), ALLOCATABLE :: a(:,:), tau(:), work(:)
       CHARACTER (1)                   :: clabs(1), rlabs(1)
!      .. Executable Statements ..
       WRITE (nout,*) 'F08NSF Example Program Results'
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n
       lda = n
       lwork = 64*n
       ALLOCATE (a(lda,n),tau(n-1),work(lwork))

!      Read A from data file

       READ (nin,*) (a(i,1:n),i=1,n)

!      Reduce A to upper Hessenberg form

!      The NAG name equivalent of zgehrd is f08nsf
       CALL zgehrd(n,1,n,a,lda,tau,work,lwork,info)

!      Set the elements below the first sub-diagonal to zero

       DO i = 1, n - 2
          a(i+2:n,i) = zero
       END DO

!      Print upper Hessenberg form

       WRITE (nout,*)
       FLUSH (nout)

!      ifail: behaviour on error exit
!             =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
       ifail = 0
       CALL x04dbf('General',' ',n,n,a,lda,'Bracketed','F7.4', &
          'Upper Hessenberg form','Integer',rlabs,'Integer',clabs,80,0,ifail)

    END PROGRAM f08nsfe
