    PROGRAM g05tdfe

!      G05TDF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : g05kff, g05tdf, nag_wp
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: lseed = 1, nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: genid, ifail, ip1, itype, lr,        &
                                          lstate, mode, n, np, subid
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: p(:), r(:)
       INTEGER                         :: seed(lseed)
       INTEGER, ALLOCATABLE            :: state(:), x(:)
!      .. Intrinsic Functions ..
       INTRINSIC                          ceiling, real
!      .. Executable Statements ..
       WRITE (nout,*) 'G05TDF Example Program Results'
       WRITE (nout,*)

!      Skip heading in data file
       READ (nin,*)

!      Read in the base generator information and seed
       READ (nin,*) genid, subid, seed(1)

!      Initial call to initialiser to get size of STATE array
       lstate = 0
       ALLOCATE (state(lstate))
       ifail = 0
       CALL g05kff(genid,subid,seed,lseed,state,lstate,ifail)

!      Reallocate STATE
       DEALLOCATE (state)
       ALLOCATE (state(lstate))

!      Initialize the generator to a repeatable sequence
       ifail = 0
       CALL g05kff(genid,subid,seed,lseed,state,lstate,ifail)

!      Read in sample size
       READ (nin,*) n

!      Read in the distribution parameters
       READ (nin,*) np, ip1, itype

!      Use suggested value for LR
       lr = 10 + ceiling(1.4E0_nag_wp*real(np,kind=nag_wp))

!      Generate and set up reference vector in one go
       mode = 2

       ALLOCATE (p(np),x(n),r(lr))

!      Read in probabilities
       READ (nin,*) p(1:np)

!      Generate the variates
       ifail = 0
       CALL g05tdf(mode,n,p,np,ip1,itype,r,lr,state,x,ifail)

!      Display the variates
       WRITE (nout,99999) x(1:n)

99999  FORMAT (1X,I12)
    END PROGRAM g05tdfe
