    PROGRAM x04cffe

!      X04CFF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : nag_wp, x04cff
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nmax = 5, nout = 6
       INTEGER, PARAMETER              :: lda = nmax
       CHARACTER (7), PARAMETER        :: clabs(nmax) = (/  'Un     ',         &
                                          'Deux   ',  'Trois  ',  'Quatre ',   &
                                          'Cinq   '  /)
       CHARACTER (7), PARAMETER        :: rlabs(nmax) = (/  'Uno    ',         &
                                          'Due    ',  'Tre    ',  'Quattro',   &
                                          'Cinque '  /)
!      .. Local Scalars ..
       INTEGER                         :: i, ifail, indent, j, ncols
!      .. Local Arrays ..
       REAL (KIND=nag_wp)              :: a(lda,lda)
!      .. Intrinsic Functions ..
       INTRINSIC                          real
!      .. Executable Statements ..
       WRITE (nout,*) 'X04CFF Example Program Results'

       WRITE (nout,*)
       FLUSH (nout)

!      Generate an array of data

       DO j = 1, nmax

          DO i = 1, lda
             a(i,j) = real(10*i+j,kind=nag_wp)
          END DO

       END DO

       ncols = 80
       indent = 0

!      Print nmax by nmax band matrix with 1 sub-diagonal, 1 super-diagonal,
!      default format and integer row and column labels

       ifail = 0
       CALL x04cff(nmax,nmax,1,1,a,lda,' ','Example 1:','Integer',rlabs, &
          'Integer',clabs,ncols,indent,ifail)

       WRITE (nout,*)
       FLUSH (nout)

!      Print nmax by nmax band matrix with 1 sub-diagonal, 2 super-diagonals,
!      user-supplied format and row and column labels

       ifail = 0
       CALL x04cff(nmax,nmax,1,2,a,lda,'F8.2','Example 2:','Character',rlabs, &
          'Character',clabs,ncols,indent,ifail)

       WRITE (nout,*)
       FLUSH (nout)

!      Print nmax by nmax band matrix with 1 sub-diagonal, 2 super-diagonals,
!      in MATLAB format
!      Row and column labelling is ignored

       ifail = 0
       CALL x04cff(nmax,nmax,1,2,a,lda,'MATLABF8.2','A',' ',rlabs,' ',clabs, &
          ncols,indent,ifail)

    END PROGRAM x04cffe
